#include <bits/stdc++.h>
using namespace std;

using ll = long long;

constexpr ll INF = 1e9 + 100;


struct node {
    ll val, i, j;
};

bool operator<(const node n1, const node n2) {
    return n1.val > n2.val;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, m;
    cin>>n>>m;

    ll mn[n][m];
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            mn[i][j] = INF;
        }
    }


    priority_queue<node> pq;

    pq.push({1, 2, 3});
    pq.push({2, 1, 3});


    ll a[n][m];
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            cin >> a[i][j];

            if (i == 0 || i == n - 1 || j == 0 || j == m - 1) {
                pq.push({a[i][j], i, j});
                mn[i][j] = a[i][j];
            }
        }
    }


    while (!pq.empty()) {
        node top = pq.top();
        pq.pop();

        ll i = top.i;
        ll j = top.j;

       
        ll val = top.val;

        if (val != mn[i][j]) continue;

        for (ll delx : {-1, 0, 1}) {
            for (ll dely : {-1, 0, 1}) {
                if ((delx == 0) == (dely == 0)) continue;
                if (i + delx < 0 || i + delx >= n || j + dely < 0 || j + dely >= m) continue;
                ll newval = max(min(mn[i + delx][j + dely], val), a[i + delx][j + dely]);
                if (newval < mn[i + delx][j + dely]) {
                    mn[i + delx][j + dely] = newval;
                    pq.push({newval, i + delx, j + dely});
                }
            }
        }
    }

    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            ans += mn[i][j] - a[i][j];
        }
    }

    printf("%lld\n", ans);
}
