#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
int level[901][901];
int val[901][901];
bool used[901][901];
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,m;
    cin >> n >> m;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            cin >> val[i][j];
            level[i][j] = 1e9;
        }
    }
    priority_queue<pair<int,pair<int,int>>,vector<pair<int,pair<int,int>>>,greater<pair<int,pair<int,int>>>> pq;
    for(int i = 0;i < n;i++){
        level[i][0] = val[i][0];
        level[i][m-1] = val[i][m-1];
        pq.push({level[i][0],{i,0}});
        pq.push({level[i][m-1],{i,m-1}});
    }
    for(int i = 1;i+1 < m;i++) {
        level[0][i] = val[0][i];
        level[n-1][i] = val[n-1][i];
        pq.push({level[0][i],{0,i}});
        pq.push({level[n-1][i],{n-1,i}});
    }
    while(pq.size()) {
        int i = pq.top().second.first;
        int j = pq.top().second.second;
        pq.pop();
        if(used[i][j]) continue;
        used[i][j] = 1;
        if(i and level[i-1][j] > max(level[i][j],val[i][j])) {
            level[i-1][j] = max(level[i][j],val[i][j]);
            pq.push({level[i-1][j],{i-1,j}});
        }
        if(i+1 < n and level[i+1][j] > max(level[i][j],val[i][j])) {
            level[i+1][j] = max(level[i][j],val[i][j]);
            pq.push({level[i+1][j],{i+1,j}});
        }
        if(j and level[i][j-1] > max(level[i][j],val[i][j])) {
            level[i][j-1] = max(level[i][j],val[i][j]);
            pq.push({level[i][j-1],{i,j-1}});
        }
        if(j+1 < m and level[i][j+1] > max(level[i][j],val[i][j])) {
            level[i][j+1] = max(level[i][j],val[i][j]);
            pq.push({level[i][j+1],{i,j+1}});
        }
    }
    ll ans = 0;
    for(int i = 0;i < n;i++) {
        for(int j = 0;j < m;j++) {
            ans += max(0,level[i][j]-val[i][j]);
        }
    }
    cout << ans << "\n";

}
/*
4 5
2 2 2 2 2
2 1 1 2 2
2 2 1 1 1
2 2 2 2 2
*/