#include <iostream>
#include <vector>
#include <string> 

using namespace std;
typedef long long ll;

int main() 
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, q;
	cin >> n >> m >> q;
	vector<vector<int>> d(n, vector<int>(m));
	vector<int> mx_n(n), mx_m(m), in(n), im(m);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			cin >> d[i][j];
			if (mx_n[i] < d[i][j]) 
				in[i] = j;
			if (mx_m[j] < d[i][j])
				im[j] = i;
			mx_n[i] = max(mx_n[i], d[i][j]);
			mx_m[j] = max(mx_m[j], d[i][j]);
		}
	int ob = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			if (d[i][j] == mx_n[i] && d[i][j] == mx_m[j])
				ob++;
	while (q--) {
		int r, c, x;
		cin >> r >> c >> x;
		r--, c--;
		if (d[r][c] == mx_n[r] && d[r][c] == mx_m[c]) {
			cout << ob << "\n";
			goto remembering;
		}
		if (d[r][c] == mx_n[r]) {
			if (x < mx_m[c]) {
				cout << ob << "\n";
			}
			else {
				ob++;
				if (in[im[c]] == c)
					ob--;
				cout << ob << "\n";
			}

			goto remembering;
		}

		if (d[r][c] == mx_m[c]) {
			if (x < mx_n[r]) {
				cout << ob << "\n";
			}
			else {
				ob++;
				if (im[in[r]] == r)
					ob--;
				cout << ob << "\n";
			}

			goto remembering;
		}

		if (x < mx_n[r] || x < mx_m[c]) {
			cout << ob << "\n";
			goto remembering;
		}
		ob++;
		if (in[im[c]] == c)
			ob--;
		if (im[in[r]] == r)
			ob--;

	remembering:
		if (mx_n[r] < d[r][c])
			in[r] = c;
		if (mx_m[c] < d[r][c])
			im[c] = r;
		d[r][c] = x;
		mx_n[r] = max(mx_n[r], d[r][c]);
		mx_m[c] = max(mx_m[c], d[r][c]);
	}
}