#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <queue>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct searchnode {
  ll node_index;
  searchnode *parent;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll n, m, k;
  ll a, b, c, d, e, f, g, h, j, l, mx, mn, sm;
  // freopen("in", "r", stdin);
  string str;
  char ch;
  bool bl;
  cin >> n;
  vector<ll> arr[n + 1];
  for (ll i = 0; i < n - 1; i++) {
    cin >> a >> b;
    arr[a].push_back(b);
    arr[b].push_back(a);
  }
  bool visited[n + 1];
  for (ll i = 1; i <= n; i++) {
  }
  cin >> k;
  while (k--) {
    memset(visited, false, n + 1);
    queue<searchnode *> bfs;
    cin >> a >> b;
    searchnode root = {a, nullptr};
    bfs.push(&root);
    ll answers[n + 1];
    while (!bfs.empty()) {
      searchnode *current_search = bfs.front();
      bfs.pop();
      if (visited[current_search->node_index])
        continue;
      visited[current_search->node_index] = true;
      if (current_search->parent == &root) {
        answers[current_search->node_index] = current_search->node_index;
      } else if (current_search->parent != nullptr) {
        answers[current_search->node_index] =
            answers[current_search->parent->node_index];
      }
      if (current_search->node_index == b) {
        cout << answers[current_search->node_index] << nl;
        break;
      }
      for (ll child : arr[current_search->node_index]) {
        searchnode *new_node = new searchnode();
        new_node->parent = current_search;
        new_node->node_index = child;
        bfs.push(new_node);
      }
    }
  }
}
