#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <queue>
#include <vector>

using namespace std;

#define ll int
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct searchnode {
  ll node_index;
  searchnode *parent;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll n, m, k;
  ll a, b, c, d, e, f, g, h, j, l, mx, mn, sm;
  // freopen("in", "r", stdin);
  string str;
  char ch;
  bool bl;
  cin >> n >> m;
  ll heights[n][m];
  mx = 0;
  mn = LLONG_MAX;
  for (ll i = 0; i < n; i++) {
    for (ll j = 0; j < m; j++) {
      cin >> heights[i][j];
      mx = max(mx, heights[i][j]);
      mn = min(mn, heights[i][j]);
    }
  }
  ll water[n][m];
  for (ll i = 0; i < n; i++) {
    for (ll j = 0; j < m; j++) {
      if (i == 0 || j == 0 || i == n - 1 || j == m - 1) {
        water[i][j] = 0;
      } else {
        water[i][j] = mx - mn;
      }
    }
  }
  do {
    bl = false;
    for (ll i = 1; i < n - 1; i++) {
      for (ll j = 1; j < m - 1; j++) {
        d = max(min(heights[i - 1][j] + water[i - 1][j],
                    min(heights[i + 1][j] + water[i + 1][j],
                        min(heights[i][j - 1] + water[i][j - 1],
                            heights[i][j + 1] + water[i][j + 1]))) -
                    heights[i][j],
                0);
        if (d < water[i][j]) {
          water[i][j] = d;
          bl = true;
        }
      }
    }
  } while (bl);
  ll answer = 0;
  for (ll i = 0; i < n; i++) {
    for (ll j = 0; j < m; j++) {
      answer += water[i][j];
    }
  }
  cout << answer;
}
