#include <algorithm>
#include <iostream>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int n, m, k;
  int d, e, mx, i, j;
  ll answer = 0;
  // freopen("in", "r", stdin);
  bool bl;
  cin >> n >> m;
  int heights[n][m];
  mx = 0;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
      cin >> heights[i][j];
      mx = max(mx, heights[i][j]);
    }
  }
  int water[n][m];
  for (int i = 0; i < n; i++) {
    water[i][0] = 0;
    water[i][m - 1] = 0;
  }
  for (int j = 0; j < m; j++) {
    water[0][j] = 0;
    water[n - 1][j] = 0;
  }
  for (int i = 1; i < n - 1; i++) {
    for (int j = 1; j < m - 1; j++) {
      water[i][j] = mx - heights[i][j];
    }
  }
  e = min(n, m);
  for (ll k = 1; 2 * k <= e; k++) {
    do {
      bl = false;
      for (int i = k; i < n - k; i++) {
        j = k;
        d = max(min(heights[i - 1][j] + water[i - 1][j],
                    min(heights[i + 1][j] + water[i + 1][j],
                        min(heights[i][j - 1] + water[i][j - 1],
                            heights[i][j + 1] + water[i][j + 1]))) -
                    heights[i][j],
                0);
        if (d < water[i][j]) {
          water[i][j] = d;
          bl = true;
        }
        j = m - k;
        d = max(min(heights[i - 1][j] + water[i - 1][j],
                    min(heights[i + 1][j] + water[i + 1][j],
                        min(heights[i][j - 1] + water[i][j - 1],
                            heights[i][j + 1] + water[i][j + 1]))) -
                    heights[i][j],
                0);
        if (d < water[i][j]) {
          water[i][j] = d;
          bl = true;
        }
      }
      for (int j = m; j < m - k; j++) {
        i = k;
        d = max(min(heights[i - 1][j] + water[i - 1][j],
                    min(heights[i + 1][j] + water[i + 1][j],
                        min(heights[i][j - 1] + water[i][j - 1],
                            heights[i][j + 1] + water[i][j + 1]))) -
                    heights[i][j],
                0);
        if (d < water[i][j]) {
          water[i][j] = d;
          bl = true;
        }
        i = n - k;
        d = max(min(heights[i - 1][j] + water[i - 1][j],
                    min(heights[i + 1][j] + water[i + 1][j],
                        min(heights[i][j - 1] + water[i][j - 1],
                            heights[i][j + 1] + water[i][j + 1]))) -
                    heights[i][j],
                0);
        if (d < water[i][j]) {
          water[i][j] = d;
          bl = true;
        }
      }
    } while (bl);
  }
  for (int i = 1; i < n - 1; i++) {
    for (int j = 1; j < m - 1; j++) {
      answer += water[i][j];
    }
  }
  cout << answer;
  return 0;
}
