#include<bits/stdc++.h>

#define endl '\n'

using namespace std;

const int dim = 1e4+7;

long long n, m, q, cnt;
long long d[dim][dim];

set<int> sr[dim], sc[dim];

void setup(){

    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            sr[i].insert(d[i][j]);
            sc[j].insert(d[i][j]);
        }
    }
}

bool check(int x, int y){
    return (*sr[x].rbegin()==d[x][y] && *sc[y].rbegin()==d[x][y]);
}

void check_for_all(){

    cnt = 0;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            if(check(i, j))cnt++;
        }
    }
}

int change(int r, int c, int x){

    if(check(r, c))cnt--;
    sr[r].erase(sr[r].find(d[r][c]));
    sc[c].erase(sc[c].find(d[r][c]));

    d[r][c] = x;
    sr[r].insert(x);
    sc[c].insert(x);
    if(check(r, c))cnt++;

    return cnt-1;
}

int main(){

    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m >> q;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++)cin >> d[i][j];
    }

    setup();
    check_for_all();

    long long r, c, x;
    for(int i = 1; i<=q; i++){
        cin >> r >> c >> x;
        cout << change(r, c, x) << endl;
    }

    return 0;
}
