#include<bits/stdc++.h>

#define endl '\n'

using namespace std;

const int dim = 1e4+7;

struct P{
    int x, r, c;
};

long long n, m, q, cnt;
long long d[dim][dim];

set<int> sr[dim], sc[dim];
P pr[dim], pc[dim];

void setup(){

    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            sr[i].insert(d[i][j]);
            sc[j].insert(d[i][j]);
        }
    }
}

bool check(int x, int y){
    return ((*sr[x].rbegin())==d[x][y] && (*sc[y].rbegin())==d[x][y]);
}

void check_for_all(){

    cnt = 0;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            if(check(i, j)){
                cnt++;
                pr[i] = {d[i][j], i, j};
                pc[j] = {d[i][j], i, j};
            }
        }
    }
}

void print(){
    for(int i = 1; i<=n; i++){
            cout << "   " << pr[i].x << " ";
        }
    cout << endl;
    for(int i = 1; i<=m; i++){
        cout << pc[i].x << " " << endl;
    }
}

int change(int r, int c, int x){

    P tmp1 = pr[r], tmp2 = pc[c];

    ///
    //print();
    if(check(r, c)){
        cnt--;
    }
    else{
        if(pr[r].x!=0)cnt--;
        if(pc[c].x!=0)cnt--;

        int r1 = pr[r].r, c1 = pr[r].c;
        pr[r1] = {0, 0, 0};
        pc[c1] = {0, 0, 0};

        int r2 = pc[c].r, c2 = pc[c].c;
        pr[r2] = {0, 0, 0};
        pc[c2] = {0, 0, 0};

    }
    ///
    //print();

    sr[r].erase(sr[r].find(d[r][c]));
    sc[c].erase(sc[c].find(d[r][c]));

    d[r][c] = x;
    sr[r].insert(x);
    sc[c].insert(x);

    ///
    if(check(r, c)){
        cnt++;
        pr[r] = {x, r, c};
        pc[c] = {x, r, c};
    }
    else{
        if(tmp1.x!=0)cnt++;
        if(tmp2.x!=0)cnt++;
        if(tmp1.x!=0 && tmp1.x==tmp2.x)cnt--;

        int r1 = tmp1.r, c1 = tmp1.c;
        pr[r1] = {tmp1.x, tmp1.r, tmp1.c};
        pc[c1] = {tmp1.x, tmp1.r, tmp1.c};

        int r2 = tmp2.r, c2 = tmp2.c;
        pr[r2] = {tmp2.x, tmp2.r, tmp2.c};
        pc[c2] = {tmp2.x, tmp2.r, tmp2.c};
    }

    ///
    //print();

    return cnt;
}

int main(){

    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m >> q;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++)cin >> d[i][j];
    }

    setup();
    check_for_all();

    long long r, c, x;
    for(int i = 1; i<=q; i++){

        cin >> r >> c >> x;
        cout << change(r, c, x) << endl;

//        cout << endl;
//        for(int i = 1; i<=n; i++){
//            for(int j = 1; j<=m; j++){
//                cout << d[i][j] << " ";
//            }
//            cout << endl;
//        }
//        cout << endl;
//        for(int i = 1; i<=n; i++){
//            for(int j = 1; j<=m; j++){
//                if(check(i, j))cout << 1 << " ";
//                else cout << 0 << " ";
//            }
//            cout << endl;
//        }
        //print();

    }


    return 0;
}
