#include<bits/stdc++.h>

#define endl '\n'

using namespace std;

const int dim = 2e6+7, dim2 = 20;

long long n, m, timer;
vector<int> a[dim];

long long tin[dim], tout[dim], depth[dim], d[dim][dim2];

void dfs(int v, int par){
    depth[v] = depth[par]+1;
    tin[v] = timer++;

    d[v][0] = par;
    for(int i = 1; i<dim2; i++){
        d[v][i] = d[d[v][i-1]][i-1];
    }

    for(auto x : a[v]){
        if(x!=par)dfs(x, v);
    }

    tout[v] = timer++;
}

void solve(){
    timer = 0;
    dfs(1, 1);
}

bool is_par(int v1, int v2){
    return tin[v1]<=tin[v2] && tout[v1]>=tout[v2];
}

int lca(int v1, int v2){
    if(is_par(v1, v2))return v1;
    if(is_par(v2, v1))return v2;

    for(int i = dim2-1; i>=0; i--){
        if(!is_par(d[v1][i], v2))v1 = d[v1][i];
    }
    return d[v1][0];
}

int main(){

    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n;
    int x, y;
    for(int i = 1; i<=n-1; i++){
        cin >> x >> y;
        a[x].push_back(y);
        a[y].push_back(x);
    }

    solve();

//    for(int i = 1; i<=n; i++){
//        for(int j = 5; j>=0; j--){
//            cout << d[i][j] << " ";
//        }
//        cout << endl;
//    }
    cin >> m;
    int s, t;
    for(int i = 1; i<=m; i++){
        cin >> s >> t;
        if(s!=lca(s, t))cout << d[s][0] << endl;
        else{
            for(int i = dim2-1; i>=0; i--){
                if(!is_par(d[t][i], s))t = d[t][i];
            }
            cout << t << endl;
        }
    }

    return 0;
}