#include <bits/stdc++.h>
typedef long double ld;
typedef long long ll;
using namespace std;
int dis[200001];
vector<int> help[200001];
vector<int> graph[200001];
int dp[200001][21];
void dfs(int v, int parent, int d){
    dis[v]=d;
    for(auto element : help[v]){
        if(element!=parent){
            dfs(element, v, d+1);
            graph[element].push_back(v);
        }
    }
}
int solve(int v, int d){
    int jump = 0;
    while(d!=0){
        if(d%2) v=dp[v][jump];
        d/=2;
        jump++;
    }
    return v;
}
int main(){
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    int n;
    cin >> n;
    for(int i = 0; i<n-1; i++){
        int first, second;
        cin >> first >> second;
        first--;
        second--;
        help[first].push_back(second);
        help[second].push_back(first);
    }
    dfs(0, -1, 0);
    for(ll i = 0; i<n; i++){
        if(i==0) dp[i][0]=0;
        else dp[i][0]=graph[i][0];
    }
    for(ll i = 1; i<21; i++){
        for(ll j = 0; j<n; j++){
            dp[j][i]=dp[dp[j][i-1]][i-1];
        }
    }
    int q;
    cin >> q;
    for(int i = 0; i<q; i++){
        int first, second;
        cin >> first >> second;
        first--;
        second--;
        if(dis[first]>=dis[second]){
            cout << dp[first][0]+1 << '\n';
        }
        else{
            int need = dis[second]-dis[first];
            int v = solve(second, need);
            if(v==first){
                cout << solve(second, need-1)+1 << '\n';
            }
            else{
                cout << dp[first][0]+1 << '\n';
            }
        }
    }
}
/*
5
1 2
1 3
1 4
3 5
3
5 2
1 4
4 3

*/