#include <iostream>
#include <vector>

using namespace std;
using ll = int;

vector<ll> march;

void dfs(ll ind, vector<vector<ll>> a, vector<bool> used) {
	used[ind] = true;
	march.push_back(ind);
	for (ll i = 0; i < a[ind].size(); i++) {
		if (!used[a[ind][i]]) {
			dfs(a[ind][i], a, used);
			march.push_back(ind);
		}
	}
}

int main() {
	ll n, inp1, inp2, m, coords1, coords2;
	cin >> n;
	vector<vector<ll>> a(n);
	vector<bool> used(n, false);
	for (ll i = 0; i < n-1; i++) {
		cin >> inp1 >> inp2;
		inp1--;
		inp2--;
		a[inp1].push_back(inp2);
		a[inp2].push_back(inp1);
	}
	cin >> m;
	dfs(0, a, used);
	for (ll i = 0; i < m; i++) {
		cin >> inp1 >> inp2;
		inp1--;
		inp2--;
		coords1 = -1;
		coords2 = -1;
		for (ll j = 0; j < march.size() && (coords1 == -1 || coords2 == -1); j++) {
			if (march[j] == inp2) {
				coords2 = j;
			}
			if (march[j] == inp1) {
				coords1 = j;
			}
		}
		if (coords2 < coords1) {
			cout << march[coords1 - 1]+1 << '\n';
		}
		else {
			cout << march[coords1 + 1]+1 << '\n';
		}
	}
}