#include <bits/stdc++.h>

using namespace std;

int n, m, ans=0;
int h[1000][1000], used[1000][1000];

int flood(int x, int y, int he)
{
    if(x<0||y<0||x>=n||y>=m)
        return -1;

    if(h[x][y]>he||used[x][y]==he)
        return 0;

    used[x][y]=he;

    int f1=flood(x+1, y, he);
    int f2=flood(x-1, y, he);
    int f3=flood(x, y+1, he);
    int f4=flood(x, y-1, he);
    if(f1==-1||f2==-1||f3==-1||f4==-1)
        return -1;

    return f1+f2+f3+f4+1;
}

void flood_level(int level)
{
    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++)
            if(used[i][j]<level)
            {
                int q=flood(i, j, level);

                if(q>0)
                    ans+=q;
            }
}

int main()
{
    int mn=1000000009, mx=0;

    cin>>n>>m;

    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++)
        {
            cin>>h[i][j];
            used[i][j]=0;

            mx=max(mx, h[i][j]);
            mn=min(mn, h[i][j]);
        }

    for(int i=mn; i<mx; i++)
        flood_level(i);

    cout<<ans;

    return 0;
}
