#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n, m, q; cin>>n>>m>>q;
    int d[n + 1][m + 1];
    vector<int> mr(n + 1), mc(m + 1), ir(n + 1), ic(m + 1);
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            cin>>d[i][j];
            if (d[i][j] > mr[i]){
                mr[i] = d[i][j];
                ir[i] = j;
            }
            if (d[i][j] > mc[j]){
                mc[j] = d[i][j];
                ic[j] = i;
            }
        }
    }
    set<pii> st;
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= n; j++){
            if (d[i][j] == max(mr[i], mc[j])){
                st.insert({i, j});
            }
        }
    }
    // (i, j): d[i][j] = max(mr[i], mc[j])
    while (q--){
        int r, c, x; cin>>r>>c>>x;
        if (x > mr[r]){
            pii t = {r, ir[r]};
            auto it = st.find(t);
            if (it != st.end()) st.erase(it);
            mr[r] = x;
            ir[r] = c;
        }
        if (x > mc[c]){
            pii t = {ic[c], c};
            auto it = st.find(t);
            if (it != st.end()) st.erase(it);
            mc[c] = x;
            ic[c] = r;
        }
        d[r][c] = x;
        int out = 0;
        for (int i = 1; i <= n; i++){
            for (int j = 1; j <= m; j++){
                if (d[i][j] == max(mr[i], mc[j])){
                    out++;
                }
            }
        }
        if (mr[r] == x && mc[c] == x) st.insert({r, c});
        if (out > st.size() + 5) return 1;
        cout<<out<<"\n";
    }
}