#include <bits/stdc++.h>
using namespace std;

#define DIMN 907

int n, m, curheight = 1e9;
int a[DIMN][DIMN];
int b[DIMN][DIMN];
int u[DIMN][DIMN];
pair<int,int> par[DIMN][DIMN];

pair<int,int> get_parent(int x, int y) {
    if (make_pair(x,y) == par[x][y]) {
        return {x,y};
    }
    return par[x][y] = get_parent(x,y);
}

void unit(pair<int,int> p1, pair<int,int> p2) {
    p1 = get_parent(p1.first,p1.second);
    p2 = get_parent(p2.first,p2.second);
    par[p1.first][p1.second] = p2;
}

void super_secret_search(int x, int y, int k) {
    queue<pair<pair<int,int>,int>> q;
    vector<pair<int,int>> ds[4];
    int dk[4] = {1,1,1,1};
    q.push({{x+1,y},0});
    q.push({{x-1,y},1});
    q.push({{x,y+1},2});
    q.push({{x,y-1},3});
    while(!q.empty()) {
        int xx = q.front().first.first;
        int yy = q.front().first.second;
        int kk = q.front().second;
        q.pop();
        dk[kk]--;
        //cout << b[xx][yy]<<u[xx][yy]<<dk[kk]<<endl;
        if (b[xx][yy]>0||u[xx][yy]||dk[kk]<0) {
            if (dk[kk]==0) {
                k--;
            }
            if (k == 0) break;
            continue;
        }
        u[xx][yy] = 1;
        ds[kk].push_back({xx,yy});
        if (xx==0||yy==0||xx>n||yy>m) {
            dk[kk] = -1;
            //k--;
            continue;
        }
        
        dk[kk]+=4;
        q.push({{xx+1,yy},kk});
        q.push({{xx-1,yy},kk});
        q.push({{xx,yy+1},kk});
        q.push({{xx,yy-1},kk});
    }
    for (int kk = 0; kk < 4; kk++) {
        if (dk[kk]==0) for (auto i : ds[kk]) b[i.first][i.second] = -1;
        for (auto i : ds[kk]) u[i.first][i.second] = 0;
    }
}

pair<long long,pair<long long,long long>> minsum(int x, int y) {
    if (x <= 0 || y <= 0 || x > n || y > m) return {10000000000,{0,0}};
    if (u[x][y]!=0) return {10000000000,{0,0}};
    if (b[x][y]!=-1) return {b[x][y],{0,0}};
    u[x][y] = 1;
    long long mn = 1e9, s = a[x][y], k = 1;
    auto z = minsum(x+1,y); mn = min(z.first,mn); s += z.second.first; k+=z.second.second;
    z = minsum(x-1,y); mn = min(z.first,mn); s += z.second.first; k+=z.second.second;
    z = minsum(x,y+1); mn = min(z.first,mn); s += z.second.first; k+=z.second.second;
    z = minsum(x,y-1); mn = min(z.first,mn); s += z.second.first; k+=z.second.second;
    return {mn,{s,k}};
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    vector<pair<int,pair<int,int>>> v;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> a[i][j];
            v.push_back({a[i][j],{i,j}});
        }
    }
    sort(v.begin(),v.end());

    for (int i = v.size()-1; i >= 0; i--) {
        if(b[v[i].second.first][v[i].second.second]==-1) continue;
        b[v[i].second.first][v[i].second.second] = a[v[i].second.first][v[i].second.second];

        //if (i == 11) {
            //cout << v[i].first << endl;
        super_secret_search(v[i].second.first,v[i].second.second, 4);
            /*for (int i = 1; i <= n; i++) {
                for (int j = 1; j <= m; j++) {
                    cout << b[i][j] << " ";
                }
                cout << endl;
            }*/
        //}
    }
    long long sum = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if(u[i][j]==0&&b[i][j]==-1){
                auto x = minsum(i,j);
                sum += x.first*x.second.second - x.second.first;
            }
        }
    }
    cout << sum;
}
