#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <queue>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct searchnode {
  ll node_index;
  ll parent;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll n, m, k;
  ll a, b, c, d, e, f, g, h, j, l, mx, mn, sm;
  // freopen("in", "r", stdin);
  string str;
  char ch;
  bool bl;
  cin >> n;
  ll answers[n + 1][n + 1];
  for (ll i = 1; i <= n; i++) {
    for (ll j = 1; j <= n; j++) {
      if (i == j)
        answers[i][i] = i;
      else
        answers[i][j] = 0;
    }
  }
  for (ll i = 0; i < n - 1; i++) {
    cin >> a >> b;
    answers[a][b] = b;
    answers[b][a] = a;
    for (ll j = 1; j <= n; j++) {
      if (answers[a][j] != 0 && answers[b][j] == 0) {
        answers[b][j] = a;
        answers[j][b] = answers[j][a];
      }
      if (answers[b][j] != 0 && answers[a][j] == 0) {
        answers[a][j] = b;
        answers[j][a] = answers[j][b];
      }
    }
    for (ll j = 1; j <= n; j++) {
      for (ll k = 1; k <= n; k++) {
        if (answers[a][k] != 0 && answers[a][j] != 0 && answers[k][j] == 0) {
          answers[j][k] = answers[j][a];
          answers[k][j] = answers[k][a];
        }
      }
    }
  }
  cin >> k;
  while (k--) {
    cin >> a >> b;
    cout << answers[a][b] << nl;
  }
}
