#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <queue>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct searchnode {
  ll node_index;
  ll parent;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll n, m, k;
  ll a, b, c, d, e, f, g, h, j, l, mx, mn, sm;
  //freopen("in", "r", stdin);
  string str;
  char ch;
  bool bl;
  cin >> n;
  ll answers[n + 1][n + 1];
  bool seen[n + 1];
  memset(seen, false, n + 1);
  for (ll i = 1; i <= n; i++) {
    for (ll j = 1; j <= n; j++) {
      if (i == j)
        answers[i][i] = i;
      else
        answers[i][j] = 0;
    }
  }
  for (ll i = 0; i < n - 1; i++) {
    cin >> a >> b;
    answers[a][b] = b;
    answers[b][a] = a;
    seen[a] = true;
    seen[b] = true;
    for (ll j = 1; j <= n; j++) {
      if (!seen[j])
        continue;
      for (ll k = 1; k <= n; k++) {
        if (!seen[k])
          continue;
        if (answers[j][k] == 0 && answers[j][a] != 0 && answers[k][b] != 0) {
          if (j != a)
            answers[j][k] = answers[j][a];
          else
            answers[j][k] = b;
          if (k != b)
            answers[k][j] = answers[k][b];
          else
            answers[k][j] = a;
        }
      }
    }
  }
  cin >> k;
  while (k--) {
    cin >> a >> b;
    cout << answers[a][b] << nl;
  }
}
