#include<bits/stdc++.h>

#define endl '\n'

using namespace std;

const int dim = 1e4+7;

struct P{
    int pr, pc, px;
};

long long n, m, q, cnt;
long long d[dim][dim];

P pn[dim], pm[dim];

set<int> sr[dim], sc[dim];

void setup(){

    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            sr[i].insert(d[i][j]);
            sc[j].insert(d[i][j]);
        }
    }
}

bool check(int x, int y){
    return (*sr[x].rbegin()==d[x][y] && *sc[y].rbegin()==d[x][y]);
}

void check_for_all(){

    cnt = 0;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            if(check(i, j)){
                cnt++;
                pn[i] = {i, j, d[i][j]};
                pm[j] = {i, j, d[i][j]};
            }
        }
    }
}

int change(int r, int c, int x){

    if(check(r, c))cnt--;
    else{
        if(pn[r].pr!=0)cnt--;
        if(pm[c].pr!=0)cnt--;
    }
    sr[r].erase(sr[r].find(d[r][c]));
    sc[c].erase(sc[c].find(d[r][c]));

    d[r][c] = x;
    sr[r].insert(x);
    sc[c].insert(x);
    if(check(r, c)){
        cnt++;
        pn[r] = {r, c, x};
        pm[c] = {r, c, x};
    }
    else{
        if(pn[r].pr!=0)cnt++;
        if(pm[c].pr!=0)cnt++;
        if(pn[r].px==pm[c].px)cnt--;
    }

    return cnt;
}

int main(){

    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m >> q;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++)cin >> d[i][j];
    }

    setup();
    check_for_all();

    long long r, c, x;
    for(int i = 1; i<=q; i++){

        cin >> r >> c >> x;
        cout << change(r, c, x) << endl;

//        for(int i = 1; i<=n; i++){
//            for(int j = 1; j<=m; j++){
//                cout << d[i][j] << " ";
//            }
//            cout << endl;
//        }
//        for(int i = 1; i<=n; i++){
//            for(int j = 1; j<=m; j++){
//                if(check(i, j))cout << 1 << " ";
//                else cout << 0 << " ";
//            }
//            cout << endl;
//        }

    }


    return 0;
}
