#include<bits/stdc++.h>

#define endl '\n'

using namespace std;

const int dim = 1e4+7;

struct P{
    int x, r, c;
};

long long n, m, q, cnt;
long long d[dim][dim];

//set<int> sr[dim], sc[dim];
vector<P> sr[dim], sc[dim];

bool cmp(P p1, P p2){
    return p1.x>p2.x;
}

void setup(){

    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            sr[i].push_back({d[i][j], i, j});
            sc[j].push_back({d[i][j], i, j});
        }
    }
    for(int i = 1; i<=n; i++)sort(sr[i].begin(), sr[i].end(), cmp);
    for(int i = 1; i<=m; i++)sort(sc[i].begin(), sc[i].end(), cmp);
}

bool check(int x, int y){
    return (sr[x][0].x==d[x][y] && sc[y][0].x==d[x][y]);
}

void check_for_all(){

    cnt = 0;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            if(check(i, j)){
                cnt++;
            }
        }
    }
}

void print(){
    cout << endl;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            cout << d[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            if(check(i, j))cout << 1 << " ";
            else cout << 0 << " ";
        }
        cout << endl;
    }

    cout << "ROWS:" << endl;
    for(int i = 1; i<=n; i++){
        for(auto x: sr[i])cout << x.x << " ";
        cout << endl;
    }

    cout << "COLS:" << endl;
    for(int i = 1; i<=m; i++){
        for(auto x: sc[i])cout << x.x << " ";
        cout << endl;
    }
}

int bins(vector<P> &v, int x){
    int l = 0, r = v.size()-1, tm;
    while(l<r){
        tm = (l+r)/2;
        if(v[tm].x==x){l = tm; break;}
        else if(v[tm].x>x)l = tm+1;
        else r = tm-1;
    }
    return l;
}

int change(int r, int c, int x){

    ///

    if(check(r, c))cnt--;
    else{
        if(check(sr[r][0].r, sr[r][0].c))cnt--;
        if(check(sc[c][0].r, sc[c][0].c))cnt--;
    }

    ///

    sr[r].erase(sr[r].begin()+bins(sr[r], d[r][c]));
    sc[c].erase(sc[c].begin()+bins(sc[c], d[r][c]));

    d[r][c] = x;
    sr[r].push_back({x, r, c});
    sc[c].push_back({x, r, c});
    sort(sr[r].begin(), sr[r].end(), cmp);
    sort(sc[c].begin(), sc[c].end(), cmp);

    ///

    if(check(r, c))cnt++;
    else{
        if(check(sr[r][0].r, sr[r][0].c))cnt++;
        if(check(sc[c][0].r, sc[c][0].c))cnt++;
    }

    ///
    //print();

    return cnt;
}

int main(){

    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m >> q;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++)cin >> d[i][j];
    }

    setup();
    check_for_all();

    long long r, c, x;
    for(int i = 1; i<=q; i++){

        cin >> r >> c >> x;
        cout << change(r, c, x) << endl;

        //print();

    }


    return 0;
}
