#include <bits/stdc++.h>
using namespace std;

struct Node{
    int par;
    map<int, int> pred;
};

Node tree[200005];
// Node tree[10];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    
    vector<list<int>> ed(n+1);
    int v, u;
    for (int i=0;i<n-1;++i) {
        cin>>v>>u;
        ed[v].push_back(u);
        ed[u].push_back(v);
    }
    tree[1].par = -1;
    stack<int> st;
    st.push(1);
    int x;
    while (!st.empty()) {
        x = st.top();
        if (ed[x].size()<=1 && tree[x].par != -1) {
            ed[x].clear();
            for (auto itr = tree[x].pred.begin(); itr!=tree[x].pred.end();++itr) {
                tree[tree[x].par].pred[itr->first] = x;
            }
            tree[tree[x].par].pred[x] = x;
            st.pop();
        } else {
            if (tree[x].par == -1) st.pop();
            for (auto itr=ed[x].begin();itr!=ed[x].end();++itr) {
                if (tree[x].par != (*itr)) {
                    tree[(*itr)].par = x;
                    st.push((*itr));
                }
            }
            ed[x].clear();
        }
    }
    ed.clear();
    int m;
    cin>>m;
    int s, t;
    for (int i=0;i<m;++i) {
        cin>>s>>t;
        if (tree[s].pred.find(t) == tree[s].pred.end()) cout<<tree[s].par<<'\n';
        else cout<<tree[s].pred[t]<<'\n';
    }
}
