#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;

ll numofpicks(vector<pair<ll, bool>>& a, vector<pair<ll, bool>>& b) {
	ll ans = 0;
	for (ll i = 0; i < a.size(); i++) {
		for (ll j = 0; j < b.size(); j++) {
			if (a[i].first == b[j].first) {
				a[i].second = false; 
				b[j].second = false;
				ans++;
				break;
			}
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll n, m, q, inp1, r, c, x, ans;
	cin >> n >> m >> q;
	vector<pair<ll, bool>> maxn(n, {0, true});
	vector<pair<ll, bool>> maxm(m, {0, true});
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			cin >> inp1;
			if (inp1 > maxn[i].first) {
				maxn[i].first = inp1;
			}
			if (inp1 > maxm[j].first) {
				maxm[j].first = inp1;
			}
		}
	}
	ans = numofpicks(maxn, maxm);
	for (ll i = 0; i < q; i++) {
		cin >> r >> c >> x;
		r--;
		c--;
		if (maxn[r].second && maxm[c].second) {
			ans++;
		}
		cout << ans << '\n';
	}
}