#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;

ll numofpicks(vector<pair<ll, bool>>& a, vector<pair<ll, bool>>& b, vector<ll>& ca, vector<ll>& cb) {
	ll ans = 0;
	for (ll i = 0; i < a.size(); i++) {
		for (ll j = 0; j < b.size(); j++) {
			if (a[i].first == b[j].first) {
				a[i].second = false; 
				ca[i] = j;
				b[j].second = false;
				cb[j] = i;
				ans++;
				break;
			}
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	ll n, m, q, inp1, r, c, x, ans;
	cin >> n >> m >> q;
	vector<pair<ll, bool>> maxn(n, {0, true});
	vector<pair<ll, bool>> maxm(m, {0, true});
	vector<ll> contactn(n);
	vector<ll> contactm(m);
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			cin >> inp1;
			if (inp1 > maxn[i].first) {
				maxn[i].first = inp1;
			}
			if (inp1 > maxm[j].first) {
				maxm[j].first = inp1;
			}
		}
	}
	ans = numofpicks(maxn, maxm, contactn, contactm);
	for (ll i = 0; i < q; i++) {
		cin >> r >> c >> x;
		r--;
		c--;
		if (maxn[r].second && maxm[c].second && x > maxn[r].first && x > maxm[c].first) {
			maxn[r].second = false;
			maxm[c].second = false;
			maxm[c].first = x;
			maxn[r].first = x;
			ans++;
		}
		if (!maxn[r].second && x > maxn[r].first && x < maxm[c].first) {
			maxn[r].second = true;
			maxn[r].first = x;
			maxm[contactn[r]].second = true;
			maxm[contactn[r]].first = max(maxm[contactn[r]].first, x);
			contactn[c] = -1;
			contactm[contactn[c]] = -1;
			ans--;
		}
		if (!maxm[c].second && x > maxm[c].first && x < maxn[r].first) {
			maxm[c].second = true;
			maxm[c].first = x;
			maxn[contactm[c]].second = true;
			maxn[contactm[c]].first = max(maxn[contactm[c]].first, x);
			contactm[c] = -1;
			contactn[contactm[c]] = -1;
			ans--;
		}
		cout << ans << '\n';
	}
}