#include <bits/stdc++.h>

using namespace std;

int n, m, ans=0;
int h[1000][1000], invh[1000][1000];
bool used[1000][1000];

bool check(int x, int y)
{
    if(x<1||y<1||x>n||y>m)
        return 0;

    if(used[x][y])
        return 0;

    return 1;
}

int main()
{
    int mn=1000000009, mx=0;

    cin>>n>>m;

    for(int i=1; i<=n; i++)
        for(int j=1; j<=m; j++)
        {
            cin>>h[i][j];
            used[i][j]=0;
            invh[i][j]=1000000009;

            mx=max(mx, h[i][j]);
            mn=min(mn, h[i][j]);
        }

    vector<pair<int, int>> ps;

    for(int i=0; i<=n+1; i++)
    {
        used[i][0]=1;
        invh[i][0]=0;
        used[i][m+1]=1;
        invh[i][m+1]=0;

        ps.push_back(make_pair(i, 0));
        ps.push_back(make_pair(i, m+1));
    }

    for(int i=0; i<=m+1; i++)
    {
        used[0][i]=1;
        invh[0][i]=0;
        used[n+1][i]=1;
        invh[n+1][i]=0;

        ps.push_back(make_pair(0, i));
        ps.push_back(make_pair(n+1, i));
    }

    int mininv=0;

    while(ps.size()>0)
    {
        int l=1, newmininv=1000000009;

        for(int i=0; i<ps.size(); i+=l)
        {
            l=1;

            int x1=ps[i].first;
            int y1=ps[i].second;

            if(h[x1][y1]==mininv)
            {
                if(check(x1+1, y1))
                {
                    ps.push_back(make_pair(x1+1, y1));
                    invh[x1+1][y1]=max(h[x1+1][y1], min(invh[x1+1][y1], invh[x1][y1]));
                    used[x1+1][y1]=1;
                }
                if(check(x1-1, y1))
                {
                    ps.push_back(make_pair(x1-1, y1));
                    invh[x1-1][y1]=max(h[x1-1][y1], min(invh[x1-1][y1], invh[x1][y1]));
                    used[x1-1][y1]=1;
                }
                if(check(x1, y1+1))
                {
                    ps.push_back(make_pair(x1, y1+1));
                    invh[x1][y1+1]=max(h[x1][y1+1], min(invh[x1][y1+1], invh[x1][y1]));
                    used[x1][y1+1]=1;
                }
                if(check(x1, y1-1))
                {
                    ps.push_back(make_pair(x1, y1-1));
                    invh[x1][y1-1]=max(h[x1][y1-1], min(invh[x1][y1-1], invh[x1][y1]));
                    used[x1][y1-1]=1;
                }

                ps.erase(ps.begin()+i);
                l=0;
            }
            else
                newmininv=min(newmininv, h[x1][y1]);
        }

        mininv=newmininv;
    }

    for(int i=1; i<=n; i++)
        for(int j=1; j<=m; j++)
            ans+=invh[i][j]-h[i][j];

    cout<<ans;

    return 0;
}
