#include <bits/stdc++.h>

using namespace std;

int n, m, ans=0;
int h[1000][1000], invh[1000][1000], used1[1000][1000];
bool used[1000][1000];

bool check(int x, int y)
{
    if(x<0||y<0||x>n+1||y>m+1)
        return 0;

    if(used[x][y])
        return 0;

    return 1;
}

void fun1()
{
    vector<pair<int, int>> ps;

    for(int i=0; i<=n+1; i++)
    {
        used[i][0]=1;
        invh[i][0]=0;
        used[i][m+1]=1;
        invh[i][m+1]=0;

        ps.push_back(make_pair(i, 0));
        ps.push_back(make_pair(i, m+1));
    }

    for(int i=0; i<=m+1; i++)
    {
        used[0][i]=1;
        invh[0][i]=0;
        used[n+1][i]=1;
        invh[n+1][i]=0;

        ps.push_back(make_pair(0, i));
        ps.push_back(make_pair(n+1, i));
    }

    int mininv=0;

    while(ps.size()>0)
    {
        int l=1, newmininv=10000000009;

        for(int i=0; i<ps.size(); i+=l)
        {
            l=1;

            int x1=ps[i].first;
            int y1=ps[i].second;

            if(invh[x1][y1]==mininv)
            {
                if(check(x1+1, y1))
                {
                    ps.push_back(make_pair(x1+1, y1));
                    invh[x1+1][y1]=max(h[x1+1][y1], min(invh[x1+1][y1], invh[x1][y1]));
                    used[x1+1][y1]=1;
                }
                if(check(x1-1, y1))
                {
                    ps.push_back(make_pair(x1-1, y1));
                    invh[x1-1][y1]=max(h[x1-1][y1], min(invh[x1-1][y1], invh[x1][y1]));
                    used[x1-1][y1]=1;
                }
                if(check(x1, y1+1))
                {
                    ps.push_back(make_pair(x1, y1+1));
                    invh[x1][y1+1]=max(h[x1][y1+1], min(invh[x1][y1+1], invh[x1][y1]));
                    used[x1][y1+1]=1;
                }
                if(check(x1, y1-1))
                {
                    ps.push_back(make_pair(x1, y1-1));
                    invh[x1][y1-1]=max(h[x1][y1-1], min(invh[x1][y1-1], invh[x1][y1]));
                    used[x1][y1-1]=1;
                }

                ps.erase(ps.begin()+i);
                l=0;
            }
            else
                newmininv=min(newmininv, invh[x1][y1]);
        }

        mininv=newmininv;
    }

    for(int i=1; i<=n; i++)
        for(int j=1; j<=m; j++)
            ans+=invh[i][j]-h[i][j];

    return;
}

int flood(int x, int y, int he)
{
    if(x<1||y<1||x>n||y>m)
        return -1;

    if(h[x][y]>he||used1[x][y]==he)
        return 0;

    used1[x][y]=he;

    int f1=flood(x+1, y, he);
    int f2=flood(x-1, y, he);
    int f3=flood(x, y+1, he);
    int f4=flood(x, y-1, he);
    if(f1==-1||f2==-1||f3==-1||f4==-1)
        return -1;

    return f1+f2+f3+f4+1;
}

void flood_level(int level)
{
    for(int i=1; i<=n; i++)
        for(int j=1; j<=m; j++)
            if(used1[i][j]<level)
            {
                int q=flood(i, j, level);

                if(q>0)
                    ans+=q;
            }
}

int main()
{
    int mn=10000000009, mx=0;

    cin>>n>>m;

    for(int i=1; i<=n; i++)
        for(int j=1; j<=m; j++)
        {
            cin>>h[j][i];
            used[i][j]=0;
            used1[i][j]=0;
            invh[i][j]=10000000009;

            mx=max(mx, h[i][j]);
            mn=min(mn, h[i][j]);
        }

    if(mx<=300)
    {
        for(int i=mn; i<mx; i++)
            flood_level(i);
    }
    else
        fun1();

    cout<<ans;

    return 0;
}
